/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.mappers.VolumeRenderer;

import java.util.Hashtable;
import javax.swing.JLabel;
import javax.swing.JPanel;
import org.visnow.jscic.RegularField;
import org.visnow.vn.geometries.events.ColorListener;
import org.visnow.vn.geometries.gui.DataMappingGUI;
import org.visnow.vn.geometries.parameters.DataMappingParams;
import org.visnow.vn.lib.gui.cropUI.CropUI;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw, ICM
 */
public class GUI extends JPanel
{

    /**
     * Holds value of property parentModule.
     */
    private Params params = new Params();
    protected DataMappingParams dataMappingParams;
    protected RegularField field = null;
    private final String[] densities = {"<html>very<p>coarse</html>", "coarse", "std", "fine", "<html>very<p>fine</html>", "<html>super<p>fine</html>"};

    /**
     * Creates new form VolRenderUI
     */
    public GUI()
    {
        initComponents();
        cropUI.setDynamic(true);
        dataMappingGUI.setStartNullTransparencyComponent(false);
        dataMappingGUI.setShowNodeCellPanel(false);
        dataMappingGUI.panelFold(DataMappingGUI.FoldablePanel.Transparency, true);
        Hashtable labelTable = new Hashtable();
        for (int i = 0; i < densities.length; i++) 
            labelTable.put( new Integer(10 * i), new JLabel(densities[i]) );
        globalResSlider.setLabelTable(labelTable);
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroup1 = new javax.swing.ButtonGroup();
        mainPane = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        dataMappingGUI = new org.visnow.vn.geometries.gui.DataMappingGUI();
        globalResSlider = new javax.swing.JSlider();
        jPanel2 = new javax.swing.JPanel();
        volumeShadingPanel = new org.visnow.vn.geometries.gui.VolumeShadingGUI();
        jPanel3 = new javax.swing.JPanel();
        cropPanel = new javax.swing.JPanel();
        cropUI = new org.visnow.vn.lib.gui.cropUI.CropUI();
        outButton = new javax.swing.JButton();
        filler = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 32767));

        setLayout(new java.awt.GridBagLayout());

        jPanel1.setLayout(new java.awt.BorderLayout());
        jPanel1.add(dataMappingGUI, java.awt.BorderLayout.CENTER);

        globalResSlider.setMajorTickSpacing(10);
        globalResSlider.setMaximum(50);
        globalResSlider.setMinorTickSpacing(2);
        globalResSlider.setPaintLabels(true);
        globalResSlider.setPaintTicks(true);
        globalResSlider.setValue(20);
        globalResSlider.setBorder(javax.swing.BorderFactory.createTitledBorder("resolution"));
        globalResSlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                globalResSliderStateChanged(evt);
            }
        });
        jPanel1.add(globalResSlider, java.awt.BorderLayout.NORTH);

        mainPane.addTab("data mapping", jPanel1);

        jPanel2.setLayout(new java.awt.GridBagLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanel2.add(volumeShadingPanel, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 1.0;
        jPanel2.add(jPanel3, gridBagConstraints);

        mainPane.addTab("shading", jPanel2);

        cropPanel.setLayout(new java.awt.GridBagLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        cropPanel.add(cropUI, gridBagConstraints);

        outButton.setText("output cropped field");
        outButton.setName(""); // NOI18N
        outButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                outButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        cropPanel.add(outButton, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.weighty = 1.0;
        cropPanel.add(filler, gridBagConstraints);

        mainPane.addTab("crop", cropPanel);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        add(mainPane, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void outButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_outButtonActionPerformed
    {//GEN-HEADEREND:event_outButtonActionPerformed
        params.setOutCroppedField();
    }//GEN-LAST:event_outButtonActionPerformed

    private void globalResSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_globalResSliderStateChanged
        if (!globalResSlider.getValueIsAdjusting()) {
            int res = (int)(64 * Math.pow(2, globalResSlider.getValue() / 10.));
            params.setResolution(res);
        }
    }//GEN-LAST:event_globalResSliderStateChanged

    public void setInField(RegularField inField, DataMappingParams mapParams)
    {
        this.field = inField;
        if (inField == null) {
            int[] tmp = {10, 10, 10};
            cropUI.setNewExtents(tmp);
            cropUI.setEnabled(false);
            dataMappingGUI.setInData(null, mapParams);
            return;
        }
        cropUI.setNewExtents(inField.getDims());
        cropUI.setEnabled(true);
        dataMappingGUI.setInData(inField, mapParams);
    }

    public CropUI getCropUI()
    {
        return cropUI;
    }

    public ColorListener getBackgroundColorListener()
    {
        return dataMappingGUI.getBackgroundColorListener();
    }

    public void setParams(Params params)
    {
        this.params = params;
        volumeShadingPanel.setParams(params.getShadingParams());
    }

    public void setDataMappingParams(DataMappingParams params)
    {
        dataMappingParams = params;
        dataMappingGUI.setParams(dataMappingParams);
    }
    
    public void setVisibleResSlider(boolean visibleResSlider)
    {
        globalResSlider.setVisible(visibleResSlider);
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JPanel cropPanel;
    private org.visnow.vn.lib.gui.cropUI.CropUI cropUI;
    private org.visnow.vn.geometries.gui.DataMappingGUI dataMappingGUI;
    private javax.swing.Box.Filler filler;
    private javax.swing.JSlider globalResSlider;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JTabbedPane mainPane;
    private javax.swing.JButton outButton;
    private org.visnow.vn.geometries.gui.VolumeShadingGUI volumeShadingPanel;
    // End of variables declaration//GEN-END:variables

}
